<template>
  <a-spin :spinning="confirmLoading">
    <customer-transfer model-value="selectedMaterials" data="materials"/>
  </a-spin>
</template>

<script>

  import { httpAction, getAction } from '@/api/manage'
  import { validateDuplicateValue } from '@/utils/util'
  import CustomerTransfer from '@comp/CustomerTransfer/index.vue'

  export default {
    name: 'RegularMaterialForm',
    components: {
      CustomerTransfer
    },
    props: {
      //表单禁用
      disabled: {
        type: Boolean,
        default: false,
        required: false
      }
    },
    data () {
      return {
        selectedMaterials:[],
        materials:[],
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        confirmLoading: false,
        validatorRules: {
           materialId: [
              { required: true, message: '请输入物料!'},
           ],
           specification: [
              { required: true, message: '请输入规格!'},
           ],
           regular: [
              { required: true, message: '请输入规程!'},
           ],
           unit: [
              { required: true, message: '请输入单位!'},
           ],
           count: [
              { required: true, message: '请输入数量!'},
           ],
        },
        url: {
          add: "/regular/regularMaterial/add",
          edit: "/regular/regularMaterial/edit",
          queryById: "/regular/regularMaterial/queryById"
        }
      }
    },
    computed: {
      formDisabled(){
        return this.disabled
      },
    },
    created () {
       //备份model原始值
      this.modelDefault = JSON.parse(JSON.stringify(this.model));
    },
    methods: {

      add () {
        this.edit(this.modelDefault);
      },
      edit (record) {
        this.model = Object.assign({}, record);
        this.visible = true;
      },
      submitForm () {
        const that = this;
        // 触发表单验证
        this.$refs.form.validate(valid => {
          if (valid) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            httpAction(httpurl,this.model,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
            })
          }
         
        })
      },
    }
  }
</script>